#!/bin/sh

# Copyright  2005 Sun Microsystems, Inc.  All rights reserved.
#
# Sun Microsystems, Inc. has intellectual property rights relating to
# technology embodied in the product that is described in this document.
# In particular, and without limitation, these intellectual property rights
# may include one or more of the U.S. patents listed at
# http://www.sun.com/patents and one or more additional patents or pending
# patent applications in the U.S. and in other countries.
#
# U.S. Government Rights - Commercial software.  Government users are subject
# to the Sun Microsystems, Inc. standard license agreement and applicable
# provisions of the FAR and its supplements.
#
# Use is subject to license terms.
#
# This distribution may include materials developed by third parties.Sun,
# Sun Microsystems and  the Sun logo are trademarks or registered trademarks
# of Sun Microsystems, Inc. in the U.S. and other countries.  
#
# Copyright  2005 Sun Microsystems, Inc. Tous droits rservs.
# Sun Microsystems, Inc. dtient les droits de proprit intellectuels relatifs
#  la technologie incorpore dans le produit qui est dcrit dans ce document.
# En particulier, et ce sans limitation, ces droits de proprit
# intellectuelle peuvent inclure un ou plus des brevets amricains lists
#  l'adresse http://www.sun.com/patents et un ou les brevets supplmentaires
# ou les applications de brevet en attente aux Etats - Unis et dans les
# autres pays.
#
# L'utilisation est soumise aux termes du contrat de licence.
#
# Cette distribution peut comprendre des composants dvelopps par des
# tierces parties.
#
# Sun,  Sun Microsystems et  le logo Sun sont des marques de fabrique ou des
# marques dposes de Sun Microsystems, Inc. aux Etats-Unis et dans
# d'autres pays.

### This script is run on 6.3 instance to dump auth configuration related 
#   data to a ldif file data/preMigrationNamedConf.ldif


${PKGDIR}/bin/ldapsearch -L -T -h $DS_HOST -p $DS_PORT -D "$AMADMIN_DN" -w $ADMINPASSWD  -b "$ROOT_AM_SUFFIX" ou=iPlanetAMAuthConfiguration dn |$EGREP -i "^[^=]*=iPlanetAMAuthConfiguration">${XML_DIR}/authtmp1.ldif

$SED 's/^dn: //' ${XML_DIR}/authtmp1.ldif >  ${XML_DIR}/authtmp2.ldif

$CP -f /dev/null ${XML_DIR}/preMigrationNamedConf.ldif

while read item 
do
${PKGDIR}/bin/ldapsearch -L -T -h $DS_HOST -p $DS_PORT -D "$AMADMIN_DN" -w $ADMINPASSWD  -b "ou=Configurations,ou=default,ou=organizationconfig,ou=1.0,"$item "(!(ou=Configurations))" sunkeyvalue >> ${XML_DIR}/preMigrationNamedConf.ldif

done < ${XML_DIR}/authtmp2.ldif
$RM ${XML_DIR}/authtmp1.ldif ${XML_DIR}/authtmp2.ldif



${PKGDIR}/bin/ldapsearch -L -h $DS_HOST -p $DS_PORT -D "$AMADMIN_DN" -w $ADMINPASSWD  -b "$ROOT_AM_SUFFIX" "(&(objectclass=LDAPsubentry) (cn=iplanetamauthconfiguration))" dn |$EGREP -i "^[^=]*=iPlanetAMAuthConfiguration"> ${XML_DIR}/authtmp1_role.ldif

$SED 's/^dn: //' ${XML_DIR}/authtmp1_role.ldif >  ${XML_DIR}/authtmp2_role.ldif

$CP -f /dev/null ${XML_DIR}/preMigrationNamedConf_role.ldif

while read item
do
${PKGDIR}/bin/ldapsearch -B -F :  -h $DS_HOST -p $DS_PORT -D "$AMADMIN_DN" -w $ADMINPASSWD  -b $item "objectclass=costemplate" >> ${XML_DIR}/preMigrationNamedConf_role.ldif

done < ${XML_DIR}/authtmp2_role.ldif

$RM ${XML_DIR}/authtmp1_role.ldif ${XML_DIR}/authtmp2_role.ldif


