#!/bin/sh

# Copyright  2005 Sun Microsystems, Inc.  All rights reserved.
#
# Sun Microsystems, Inc. has intellectual property rights relating to
# technology embodied in the product that is described in this document.
# In particular, and without limitation, these intellectual property rights
# may include one or more of the U.S. patents listed at
# http://www.sun.com/patents and one or more additional patents or pending
# patent applications in the U.S. and in other countries.
#
# U.S. Government Rights - Commercial software.  Government users are subject
# to the Sun Microsystems, Inc. standard license agreement and applicable
# provisions of the FAR and its supplements.
#
# Use is subject to license terms.
#
# This distribution may include materials developed by third parties.Sun,
# Sun Microsystems and  the Sun logo are trademarks or registered trademarks
# of Sun Microsystems, Inc. in the U.S. and other countries.  
#
# Copyright  2005 Sun Microsystems, Inc. Tous droits rservs.
# Sun Microsystems, Inc. dtient les droits de proprit intellectuels relatifs
#  la technologie incorpore dans le produit qui est dcrit dans ce document.
# En particulier, et ce sans limitation, ces droits de proprit
# intellectuelle peuvent inclure un ou plus des brevets amricains lists
#  l'adresse http://www.sun.com/patents et un ou les brevets supplmentaires
# ou les applications de brevet en attente aux Etats - Unis et dans les
# autres pays.
#
# L'utilisation est soumise aux termes du contrat de licence.
#
# Cette distribution peut comprendre des composants dvelopps par des
# tierces parties.
#
# Sun,  Sun Microsystems et  le logo Sun sont des marques de fabrique ou des
# marques dposes de Sun Microsystems, Inc. aux Etats-Unis et dans
# d'autres pays.

### This script is run after schema migration is done. It converts 
#   preMigrationNamedConf.ldif file to postMigrationNamedConf.ldif
#   using awk. postMigrateNamedConf.ldif file is loaded into 
#   directory server using ldapmodify.


. $AM_SCRIPTS_DIR/amupgradeutils

ROOT_ORG=`${PKGDIR}/bin/ldapsearch -L -T -h $DS_HOST -p $DS_PORT -D "$AMADMIN_DN" -w $ADMINPASSWD -b "$ROOT_AM_SUFFIX" -s base "ORG_NAMING_ATTR=*" "ORG_NAMING_ATTR"|$GREP -i "ORG_NAMING_ATTR: "|$AWK '{print $2}'`

$RM -f ${XML_DIR}/postMigrationNamedConf.ldif
$RM -f ${XML_DIR}/postMigrationNamedConfTmp.ldif

$AWK -f ${MIGRATION_SCRIPT_DIR}/process.awk root_org=$ROOT_ORG ${XML_DIR}/preMigrationNamedConf.ldif > ${XML_DIR}/postMigrationNamedConfTmp.ldif

$SED -e '/iplanet-am-auth-configuration/s/[A-Za-z]*\.//g' ${XML_DIR}/postMigrationNamedConfTmp.ldif >${XML_DIR}/postMigrationNamedConf.ldif

### load the ldif
create_dit "${XML_DIR}/postMigrationNamedConf.ldif"
